*============================================================================
* Demo4.PRG
*
* Demonstracao de rotina de leitura de senha bem simples
* Copyleft (1998) Ivan C Cruz
*
* Compile com: CLIPPER Demo4 /N/W/B
* Linque com:  RTLINK FILE Demo4
*============================================================================


#include "inkey.ch"


MEMVAR GetList


*-------------

PROCEDURE Main

LOCAL senha

CLEAR SCREEN

@ 10, 10 SAY "Digite a senha:"

senha := LeSenha ( 10, 26, 10 )

@ 12, 10 SAY "Senha digitada: " + senha

RETURN


*----------------------------------------------------------
* LeSenha
*
* Recebe a linha, a coluna e o nmero mximo de caracteres.
* Le e devolve a senha como valor de retorno. Aceita apenas
* as teclas ENTER, BS (para apagar) e ESC para cancelar
* a leitura.
*----------------------------------------------------------

FUNCTION LeSenha ( linha, coluna, tamanho )

LOCAL carac, senha

senha := ""
@ linha, coluna SAY REPLICATE ( " ", tamanho )
@ linha, coluna SAY REPLICATE ( "*", Len ( senha ) )

carac := InKey ( 0 )

WHILE carac <> K_ENTER .AND. carac <> K_ESC

    IF carac >= 32 .AND. carac <= 126  .AND.  Len ( senha ) < tamanho
        senha := senha + Upper ( Chr ( carac ) )
    ELSEIF carac = K_BS .AND. Len ( senha ) > 0
        senha := Left ( senha, Len ( senha ) - 1 )
    END

    @ linha, coluna SAY REPLICATE ( " ", tamanho )
    @ linha, coluna SAY REPLICATE ( "*", Len ( senha ) )

    carac := InKey ( 0 )

END

IF carac = K_ESC
    senha := ""
END

RETURN senha
